import { CryptoSession } from './session.js';
type Fetcher = (input: RequestInfo | URL, init?: RequestInit | undefined) => Promise<Response>;
export interface SecureFetchOptions extends RequestInit {
    hostname?: string;
    fetcher?: Fetcher;
}
export interface SecureResponse extends Response {
    token?: string;
    data?: object | string;
    err?: any;
}
export declare class SecureFetch extends Function {
    readonly session: CryptoSession;
    readonly hostname: string;
    readonly fetcher: Fetcher;
    options: RequestInit;
    static generate(peerKey: string | Uint8Array, options?: SecureFetchOptions): SecureFetch;
    constructor(peerKey: string | Uint8Array, secretKey: string | Uint8Array, options?: SecureFetchOptions);
    get method(): string;
    get body(): BodyInit | null | undefined;
    set body(body: BodyInit | null | undefined);
    addOptions(options?: RequestInit): void;
    addHeaders(headers: HeadersInit): void;
    fetch(path: RequestInfo | URL, options: SecureFetchOptions): Promise<SecureResponse>;
    get(path: string): Promise<SecureResponse>;
    post(path: string): Promise<SecureResponse>;
    handleResponse(res: SecureResponse): Promise<SecureResponse>;
}
export {};
//# sourceMappingURL=fetch.d.ts.map